// $Log$
// Revision 1.5  2004/02/09 19:20:29  stuart
// Port edicc.cc to STL
//
// Revision 1.4  2001/02/20 22:07:05  stuart
// rename metadata files
//
// Revision 1.3  1993/11/09  23:17:33  stuart
// dump data element info also
//
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <Btcb.h>
#include "edi.h"
#include "cicode.h"

void toUpperCase(string &s) {
  int len = s.length();
  for (int i = 0; i < len; ++i) {
    char c = s[i];
    if (isprint(c) && islower(c)) 
      s[i] = toupper(c);
  }
}

CodeDict code("/edx/AIRCO/EDI/CODE.MAST");
SegDict seg("/bms/edi/seg.dat");
cimp coderec;
btFile cof("/edx/AIRCO/EDI/CODE",BTRDONLY,Keydata(&coderec,sizeof coderec));

int main(int argc,char **argv) {
  for (int i = 1; i < argc; ++i) {
    string segname = argv[i];
    toUpperCase(segname);
    const short *p = seg[segname.c_str()];
    if (!p) {
      int e = atoi(segname.c_str());
      if (!e)
	fprintf(stderr, "Invalid Segment %s\n",segname.c_str());
      else {
	EDIitem &c = code[e];
	printf("%03d %-60s %-2s %2d %2d\n",
	  e,c.desc.c_str(),c.type.c_str(),c.min,c.max
	);
	coderec.elem = e;
	int rc = cof.readge(&coderec.elem);
	while (rc == 0 && coderec.elem == e) {
	  string code(coderec.code), desc(coderec.desc);
	  printf("  %-6s %-60s\n",code.c_str(),desc.c_str());
	  rc = cof.next();
	}
      }
    }
    else {
      int pos = 3;
      printf("*\n*Z%s00	 EQU ZZBUF	%2d C  %s\n",
	segname.c_str(),pos,seg(segname.c_str()));
      for (int j = 0; p[j]; ++j) {
	EDIitem &c = code[p[j]];
	int size = c.len();
	if (size == 0) {
	  fprintf(stderr, "Data Element %03d no be defined\n",p[j]);
	}
	pos = c.align(pos);
	printf("ZZ%s%02d	 EQU ZZBUF+%d	%2d %-2s (%03d)%s\n",
		segname.c_str(),j+1,pos,size,c.type.c_str(),
		p[j],c.desc.c_str());
	pos += size;
      }
    }
  }
  return 0;
}
