// create an EDIFACT envelope UNB/UNZ
struct EdifactEnv: EdifactSink, EDIstream {
  EdifactEnv();
  void UNB(string from, string to, bool test = false);

  // set syntax level and release, default is UNOB:2
  void syntax(const char *syn,short rel);

  // Define valid char codes.  Invalid codes 0-127 are mapped to ':'.
  // Invalid codes from 128-256 are mapped to '.'.
  void charset(const char *set);	// valid char codes

  // Charmap is used to refine the default mapping of invalid codes.
  // Invalid chars in 'from' are mapped to corresponding char in 'to'
  void charmap(const char *from, const char *to);

  int write(Segment &);
  ~EdifactEnv();
  string passwd,passwdQual;
  string ref;
  string agreement;
  char priority;
private:
  enum { MAPSIZE = 256 };
  void UNZ();
  vector<string> from, to;
  string seq;
  long grps;
  long now;
  char *map, rel;
  char syn[5];
  char toplevel;	// UNG or UNH or GS
  bool test;
};
