#pragma interface
#include <edimsg.h>

class Money; class Julday;

class EDIstream: public virtual EDIsink {
protected:
  Segment seg;
private:
  short elemidx, subidx;
public:
  EDIstream();
  //EDIstream &operator<<(Money);	// must fmt to specify fix
  EDIstream &operator<<(long);
  EDIstream &operator<<(int i) { return this->operator<<(long(i)); }
  EDIstream &operator<<(const char *);
  EDIstream &operator<<(const string &);
  EDIstream &operator<<(Julday);
  EDIstream &operator<<(char c) { return (*this) << string(1,c); }
  void nextelem();		// advance to next element
  void elem(int e,int s = 0);	// advance to specific element(,subelem)
  void endseg();		// output segment and clear
  virtual ~EDIstream();
};

struct EdifactSink: virtual EDIsink {
  enum { COMP, ELEM, DEC, ESC, RES, SEG };	// special chars
  EdifactSink(const char *spec = 0);
  void UNA(const char *);
  int write(Segment &);
  ~EdifactSink();
protected:
  char sep[8];
  bool needUNA;
};

// make message conform to EDIFACT segment/data-element dictionary
struct Edifact: EdifactSink, EDIstream  {
  Edifact(const char *spec = 0);
  void MOA(int type,Money amt,bool req = false);
  int write(Segment &);
  void close();
  ~Edifact();
private:
  string msgref;
};

struct EDImanip {
  typedef void (EDIstream::*insfn)();
  EDImanip(insfn);
  struct EDImanip2 operator()(int,int = 0);
  friend EDIstream &operator<<(EDIstream &,const EDImanip &);
private:
  insfn fn;
};

struct EDImanip2 {
  typedef void (EDIstream::*insfn)(int,int);
  EDImanip2(insfn,int,int);
  friend EDIstream &operator<<(EDIstream &,const EDImanip2 &);
private:
  insfn fn;
  int x,y;
};

extern EDImanip elem, eseg;
