#pragma interface
#include "edimsg.h"

struct SegDict;
/** A plain EDI spool file, doesn't check segments.  EDIfile is stored
 as a BTAS file with 1 segment/record and fixed length fields.  This
 is convenient for EDL programs to read/write.  The edicc utility
 generates EDL COPY source for a segment.
 */
class EDIfile: public EDIsink {
  Btcb bt;
  long seq;
  string fname,tname;		// final name, temp name
  char ok;
  struct SegDict *segdict;
public:
  EDIfile(const string &name,SegDict *vers);
  int write(Segment &);
  // report data elem error
  void error(short,short,const string &,const string &);	
  ~EDIfile();
};

// a new transaction set, generates ST and SE records with unique ID
// appends the transet ID to make the filename unique
class STfile: public EDIfile {
  string id;
public:
  STfile(const string &type,const string &filename,SegDict *vers);
  ~STfile();
};
