// $Log$
// Revision 1.8  2010/05/12 01:48:01  stuart
// Correctly read UNA header with whitespace.
//
// Revision 1.7  2006/11/16 21:55:57  stuart
// Compile on CentOS-4
//
// Revision 1.6  2004/02/09 17:28:53  stuart
// Port from libg++ to STL
//
// Revision 1.5  2001/02/20 22:07:59  stuart
// write errors to err msg
//
// Revision 1.4  1997/03/26  18:10:03  stuart
// SegmentChecker moved
//
#pragma implementation "edimsg.h"
#include <iostream>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "edimsg.h"

enum { MAXFLD = 50 };

// find ISA segment header
int EdiMsg::getISA(const char *isa,Segment &data) {
  int i = 0;
  while (!in.eof()) {
    in.get(sep);
    if (isa[i] == 0) {
      sepstr[0] = sep;
      sepstr[1] = 0;
      data.clear()+isa;
      char buf[32];
      for (i = 1; i < 16; ++i) {
	if (!in.getline(buf,sizeof buf,sep)) {
	  cerr << "ISA: bad format ";
	  for (int j = 0; j < data.size(); ++j)
	    cerr << " \"" << data[j] << '"';
	  cerr << endl;
	  return 0;
	}
	data.add(buf);
      }
      in.get(subsep);
      in.get(segsep);
      data.add(string(1,subsep));
      dec = '.';
      esc = ' ';
      return data.size();
    }
    if (sep == isa[i])
      ++i;
    else
      i = 0;
  }
  return 0;
}

EdiMsg::EdiMsg(istream &inf): in(inf) {
  // init to EDIFACT defaults, ANSI ISA will override
  esc = '?';		// no escape
  res = 0;		
  dec = ',';
  sep = '+';
  segsep = '\'';
  subsep = ':';
}

int EdiMsg::getseg(Segment &data) {
  string *s;
  int i = 0,j = 0;
  for (;;) {
    data.clear();
    while (!isalpha(in.peek()))
      if (in.get() == EOF) return 0;
    s = &data(i,j);
    // get segment id
    while (isalnum(in.peek()))
      (*s) += (char)in.get();
    // check for special segments
    if (*s != "UNA") break;
    subsep = (char)in.get();
    sep = (char)in.get();
    dec = (char)in.get();
    esc = (char)in.get();
    res = (char)in.get();
    segsep = (char)in.get();
    if (esc == ' ') esc = 0;
    if (res == ' ') res = 0;
  }
  for (;;) {
    int c = in.get();
    if (c == EOF) break;
    if (esc != ' ' && c == esc) {
      c = in.get();
    }
    else {
      if (c == segsep) break;
      if (c == subsep) {
	s = &data(i,++j);
	continue;
      }
      if (c == sep) {
	s = &data(++i,j = 0);
	continue;
      }
    }
    *s += c;
  }
  return data.size();
}

EdiMsg::~EdiMsg() {
}

EDIsink::~EDIsink() { }

void EDIsink::error(Segment &fld) {
  //cerr << "EDIsink::error(" << fld << ")\n";
  if (errs)
    errs->write(fld);
}
