#pragma implementation
#include <ostream>
#include "ediseg.h"

struct SegmentRep {
  vector<string> s;
  SegmentRep *next;
  SegmentRep() { next = 0; }
  ~SegmentRep() { delete next; }
private:
  SegmentRep(const SegmentRep&);
  SegmentRep&operator=(const SegmentRep&);
};

Segment::Segment() {
  rep = 0;
}

Segment::~Segment() {
  delete rep;
}

void Segment::add(const string &s) {
  (*this)[size()] = s;
}

int Segment::size() const {
  const SegmentRep *p = rep;
  int i;
  for (i = 0; p; ++i)
    p = p->next;
  return i;
}

int Segment::size(int elem) const {
  const SegmentRep *p = rep;
  for (int i = 0; p && i < elem; ++i)
    p = p->next;
  return p ? p->s.size() : 0;
}

string &Segment::operator()(int elem, int sub) {
  if (elem < 0) elem = size() - elem;
  if (!rep)
    rep = new SegmentRep;
  SegmentRep *p = rep;
  for (int i = 0; i < elem; ++i) {
    if (p->next)
      p = p->next;
    else
      p = p->next = new SegmentRep;
  }
  if (sub < 0) sub = p->s.size() - sub;
  while (sub >= (int)p->s.size())
    p->s.push_back("");
  return p->s[sub];
}

Segment &Segment::clear() {
  delete rep;
  rep = 0;
  return *this;
}

ostream &operator<<(ostream &os, Segment &fld) {
  for (int i = 0; i < fld.size(); ++i)
    os << " '" << fld[i] << '\'';
  return os;
}

