#ifndef _EDISEG_H
#define _EDISEG_H
#pragma interface
#include <string>
#include <vector>
#include <strutil.h>
// EDI segments were represented by Array<string>

struct Segment {
  Segment();
  string &operator[](int i) { return (*this)(i,0); }
  string &operator()(int i,int j = 0);
  void add(const string &);
  Segment &operator+(const string &s) { add(s); return *this; }
  Segment &operator+(char c) { add(string(1,c)); return *this; }
  Segment &clear();
  int size() const;
  int size(int) const;
  ~Segment();
private:
  struct SegmentRep *rep;
};

ostream &operator<<(ostream &,Segment &);

// libg++ functions missing in STL
#endif
