#include <Date.h>
#include <stdlib.h>
#include "edifact.h"
#include "edi.h"

EDIstream::EDIstream() {
  elemidx = subidx = 0;
}

EDIstream::~EDIstream() {
  endseg();
}

void EDIstream::nextelem() {
  ++elemidx;
  subidx = 0;
}

void EDIstream::elem(int e,int s) {
  elemidx = e;
  subidx = s;
}

void EDIstream::endseg() {
  if (seg.size()) {
    write(seg);
    seg.clear();
  }
  elemidx = subidx = 0;
}

EDIstream &EDIstream::operator<<(const char *s) {
  string &r = seg(elemidx,subidx++);
  r = s;
  return *this;
}

EDIstream &EDIstream::operator<<(const string &s) {
  seg(elemidx,subidx++) = s;
  return *this;
}

EDIstream &EDIstream::operator<<(long num) {
  return (*this) << dec(num);
}

EDIstream &EDIstream::operator<<(Julday m) {
  return (*this) << m.pic("YYMMDD");
}

EDImanip::EDImanip(insfn f) {
  fn = f;
}

EDIstream &operator<<(EDIstream &es,const EDImanip &m) {
  (es.*m.fn)();
  return es;
}

EDIstream &operator<<(EDIstream &es,const EDImanip2 &m) {
  (es.*m.fn)(m.x,m.y);
  return es;
}

EDImanip2::EDImanip2(insfn f,int e,int s) {
  fn = f; x = e; y = s;
}

EDImanip2 EDImanip::operator()(int e,int s) {
  return EDImanip2(&EDIstream::elem,e,s);
}

EDImanip elem(&EDIstream::nextelem);
EDImanip eseg(&EDIstream::endseg);
