#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "edi.h"

// convert alpha numeric tag to internal form
SegDict::Tag atoTag(const char *s) {
  /* for current EDIfact and ANSI standards, assume tag has the
     format Annn or nnnn:
      9999 = 09999
      A999 = 10999
      B999 = 11999
      C999 = 12999
      etc.  */
  int i = 0;
  if (!isdigit(*s))
    i = (*s++ - 'A' + 10) * 1000;
  return i + atoi(s);
}

const char *Tagtoa(SegDict::Tag i) {
  static char buf[8];
  if (i > 9999) {
    int c = i / 1000 - 10 + 'A';
    sprintf(buf,"%c%03d",c,i % 1000);
  }
  else
    sprintf(buf,"%04d",i);
  return buf;
}
