#pragma implementation
#include <iostream>
#include <Ftype.h>
#include "partner.h"

string PartnerMap::operator[](const string &addr) {
  if (addrf.keylen() == 0)
    addrf.open("PARTNERS.ADDR",BTRDONLY);
  partrec.addr = addr;	// from address
  if (addrf.readeq(&partrec.addr)) {
    cerr << "PartnerMap: '" << addr << "' not found\n";
    return "BAD";
  }
  return partrec.id;
}

string PartnerMap::fromEdiAddr(const string &id,const string &qual) {
  if (edif.keylen() == 0)
    edif.open("PARTNERS.EDIADDR",BTRDONLY);
  partrec.ediaddr = id;
  partrec.eq = qual;
  if (edif.readeq(&partrec.ediaddr + &partrec.eq)) {
    cerr << "PartnerMap: '" << id << ':' << qual << "' not found\n";
    return "BAD";
  }
  return partrec.id;
}

PartnerMap::PartnerMap():
  addrf(&partrec.addr + &partrec.id),
  edif(&partrec.ediaddr + &partrec.qual + &partrec.id)
{ }

PartnerMap::~PartnerMap() { }
